/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/slave/mozilla-central-macosx-xulrunner/build/toolkit/components/places/public/nsIPlacesImportExportService.idl
 */

package org.mozilla.interfaces;

/**
 * The PlacesImportExport interface provides methods for importing
 * and exporting Places data.
 */
public interface nsIPlacesImportExportService extends nsISupports {

  String NS_IPLACESIMPORTEXPORTSERVICE_IID =
    "{21c00314-fa63-11db-8314-0800200c9a66}";

  /**
   * Loads the given bookmarks.html file and replaces it with the current
   * bookmarks hierarchy (if aIsInitialImport is true) or appends it
   * (if aIsInitialImport is false).
   *
   * Three nsIObserverService notifications are fired as a result of the
   * import.  "bookmarks-restore-begin" is fired just before the import is
   * started.  "bookmarks-restore-success" is fired right after the
   * bookmarks are successfully imported.  "bookmarks-restore-failed" is
   * fired right after a failure occurs when importing the bookmarks.
   * Observers will be passed through their data parameters either "html"
   * if aIsInitialImport is false or "html-initial" if aIsInitialImport is
   * true.  The observer subject will be null.
   */
  void importHTMLFromFile(nsILocalFile aFile, boolean aIsInitialImport);

  /**
   * Loads the given bookmarks.html file and puts it in the given folder
   *
   * Three nsIObserverService notifications are fired as a result of the
   * import.  "bookmarks-restore-begin" is fired just before the import is
   * started.  "bookmarks-restore-success" is fired right after the
   * bookmarks are successfully imported.  "bookmarks-restore-failed" is
   * fired right after a failure occurs when importing the bookmarks.
   * Observers will be passed through their data parameters either "html"
   * if aIsInitialImport is false or "html-initial" if aIsInitialImport is
   * true.  The observer subject will be an nsISupportsPRInt64 whose value
   * is aFolder.
   */
  void importHTMLFromFileToFolder(nsILocalFile aFile, long aFolder, boolean aIsInitialImport);

  /**
   * Saves the current bookmarks hierarchy to a bookmarks.html file.
   */
  void exportHTMLToFile(nsILocalFile aFile);

  /**
   * Backup the bookmarks.html file.
   */
  void backupBookmarksFile();

}